<template>
  <div>
    <ob-modal
      ref="ob-modal"
      :title="'Настройка поля карточки ресурса'"
      :size="'medium'"
      :showControls="true"
      :submitDisabled="!savePossible"
      @cancel="close"
      @save="onSave"
      class="sb-popup sb-card-popup"
    >
      <div class="switch-tabs">
        <ob-button
          :label="'Общие настройки'"
          :type="activeTab === 'settings' ? 'primary' : 'flat'"
          :mini="true"
          @clicked="setTab('settings')"
        />
        <ob-button
          :label="'Источники данных'"
          :type="activeTab === 'sources' ? 'primary' : 'flat'"
          :mini="true"
          @clicked="setTab('sources')"
        />
      </div>

      <div v-show="activeTab == 'settings'">
        <div class="line-container block-name">
          <ob-input
            :label="'Наименование поля'"
            :placeholder="'Например, Рег. номер'"
            v-model="formData.title.label"
          />
        </div>
        <div class="block-status">
          <ob-selector
            :items="listOf.statuses"
            :label="'Статус'"
            :placeholder="'Выберите'"
            :valueExp="'value'"
            v-model="formData.is_active"
          />
        </div>
        <div class="line-container clearfix">
          <!-- :paginationFunction="paginationFunction" -->
          <!-- :searchFunction="searchFunction" -->
          <ob-selector
            :items="countriesList"
            :label="'Страна'"
            :placeholder="'Выберите'"
            :isMultiselect="true"
            :isDropdown="true"
            :count="200"
            :isTagbox="true"
            :isAutoComplete="true"
            :valueExp="'number_code'"
            :displayExp="'short_title'"
            v-model="formData.country_codes"
          />
        </div>
        <div class="block-left">
          <ob-selector
            :items="resourceClassList"
            :label="'Класс ресурса'"
            :placeholder="'Выберите'"
            :valueExp="'title'"
            v-model="formData.class_code_uuid"
          />
        </div>
        <div class="block-right">
          <ob-selector
            :items="resourceSpeciesList"
            :label="'Вид ресурса'"
            :placeholder="'Выберите'"
            :displayExp="'name'"
            :disabled="!formData.class_code_uuid"
            v-model="formData.resource_species_uuid"
          />
        </div>
        <div class="block-left">
          <ob-selector
            :items="filteredResourceTypesList"
            :label="'Тип ресурса'"
            :placeholder="'Выберите'"
            :displayExp="'name'"
            :disabled="!formData.resource_species_uuid"
            v-model="formData.resource_type_uuid"
          />
        </div>
        <div class="block-right">
          <ob-selector
            :items="requisiteGroups"
            :label="'Группа реквизитов'"
            :placeholder="'Выберите'"
            v-model="formData.requisite_group_uuid"
          />
        </div>

        <div class="block-left">
          <ob-selector
            :items="listOf.dataTypes"
            :label="'Тип данных в поле'"
            :placeholder="'Выберите'"
            :displayExp="'title'"
            :valueExp="'value'"
            v-model="formData.datatype"
          />
        </div>
        <slot v-if="formData.datatype === 'NUMERIC'">
          <div class="block-right">
            <ob-input
              :label="'Минимальное значение числа'"
              :placeholder="''"
              v-model="formData.numeric_min"
            />
          </div>
          <div class="block-left">
            <ob-input
              :label="'Максимальное значение числа'"
              :placeholder="''"
              v-model="formData.numeric_max"
            />
          </div>
          <div class="block-right">
            <ob-input
              :label="'Количество знаков после запятой'"
              :placeholder="''"
              v-model="formData.decimal_place_count"
            />
          </div>
        </slot>
        <slot v-if="formData.datatype === 'TEXT'">
          <div class="block-right">
            <ob-input
              :label="'Минимальная длина текста'"
              :placeholder="''"
              v-model="formData.text_min_len"
            />
          </div>
          <div class="block-left">
            <ob-input
              :label="'Максимальная длина текста'"
              :placeholder="''"
              v-model="formData.text_max_len"
            />
          </div>
          <div class="block-right">
            <ob-input
              :label="'Список допустимых символов'"
              :placeholder="''"
              v-model="formData.text_available_symbols"
            />
          </div>
          <div class="block-left">
            <ob-input
              :label="'Маска для текстового поля'"
              :placeholder="''"
              v-model="formData.text_mask"
            />
          </div>
        </slot>
        <div class="block-right" v-if="formData.datatype === 'BOOLEAN'">
          <ob-input
            :label="'RegExp для проверки текстового поля'"
            :placeholder="''"
            v-model="formData.text_regexp"
          />
        </div>
        <slot v-if="formData.datatype === 'CHECKLIST'">
          <div class="block-right">
            <ob-input
              :label="'Доступные варианты выбора, список UUID в виде JSON'"
              :placeholder="''"
              v-model="formData.list_variant_uuids"
            />
          </div>
          <div class="block-left">
            <ob-input
              :label="'Наименование таблицы с вариантами выбора'"
              :placeholder="''"
              v-model="formData.list_dict_table_name"
            />
          </div>
          <div class="block-right">
            <ob-input
              :label="'Минимальное количество значений выбора'"
              :placeholder="''"
              v-model="formData.list_min_count"
            />
          </div>
          <div class="block-left">
            <ob-input
              :label="'Максимальное количество значений выбора'"
              :placeholder="''"
              v-model="formData.list_max_count"
            />
          </div>
        </slot>

        <!-- DATETIME -->
        <slot v-if="formData.datatype === 'DATE'">
          <div class="line-container list-block">
            <div class="block-checkbox">
              <ob-checkbox
                :label="'Является ли минимальной датой текущий для заполнения день'"
                v-model="formData.d_is_min_today"
              />
            </div>
          </div>
          <div class="line-container list-block">
            <div class="block-checkbox">
              <ob-checkbox
                :label="'Является ли максимальной датой текущий для заполнения день'"
                v-model="formData.d_is_max_today"
              />
            </div>
          </div>
          <div class="block-left">
            <div class="line-container">
              <el-form>
                <el-form-item>
                  <el-col :span="24">
                    <div class="el-form-group">
                      <label>Минимальное значение даты</label>
                      <el-date-picker
                        v-model="formData.d_min"
                        :disabled="formData.d_is_min_today"
                        type="date"
                        placeholder=""
                        prefix-icon="app-icon app-icon--calendar"
                      />
                    </div>
                  </el-col>
                </el-form-item>
              </el-form>
            </div>
          </div>
          <div class="block-left">
            <div class="line-container">
              <el-form>
                <el-form-item>
                  <el-col :span="24">
                    <div class="el-form-group">
                      <label>Максимальное значение даты</label>
                      <el-date-picker
                        v-model="formData.d_max"
                        :disabled="formData.d_is_max_today"
                        type="date"
                        placeholder=""
                        prefix-icon="app-icon app-icon--calendar"
                      />
                    </div>
                  </el-col>
                </el-form-item>
              </el-form>
            </div>
          </div>
        </slot>
        <slot v-if="formData.datatype == 'DATETIME'">
          <div class="line-container list-block">
            <div class="block-checkbox">
              <ob-checkbox
                :label="'Является ли минимальной датой-временем текущий для заполнения момент времени'"
                v-model="formData.dt_is_min_now"
              />
            </div>
          </div>
          <div class="line-container list-block">
            <div class="block-checkbox">
              <ob-checkbox
                :label="'Является ли максимальной датой-временем текущий для заполнения момент времени'"
                v-model="formData.dt_is_max_now"
              />
            </div>
          </div>
          <div class="block-left">
            <div class="line-container">
              <el-form>
                <el-form-item>
                  <el-col :span="24">
                    <div class="el-form-group">
                      <label>Минимальное значение даты-времени</label>
                      <el-date-picker
                        v-model="formData.dt_min"
                        :disabled="formData.dt_is_min_now"
                        type="datetime"
                        placeholder=""
                        prefix-icon="app-icon app-icon--calendar"
                      />
                    </div>
                  </el-col>
                </el-form-item>
              </el-form>
            </div>
          </div>
          <div class="block-left">
            <div class="line-container">
              <el-form>
                <el-form-item>
                  <el-col :span="24">
                    <div class="el-form-group">
                      <label>Максимальное значение даты-времени</label>
                      <el-date-picker
                        v-model="formData.dt_max"
                        :disabled="formData.dt_is_max_now"
                        type="datetime"
                        placeholder=""
                        prefix-icon="app-icon app-icon--calendar"
                      />
                    </div>
                  </el-col>
                </el-form-item>
              </el-form>
            </div>
          </div>
        </slot>

        <div class="clearfix" />


        <!-- CHECKBOXES -->

        <div class="line-container list-block">
          <div class="block-checkbox">
            <ob-checkbox
              :label="'Часть регистрации'"
              v-model="formData.need_for_registration"
            />
          </div>
          <div class="block-checkbox">
            <ob-checkbox
              :label="'Часть ключа'"
              v-model="formData.is_key_part"
            />
          </div>
          <div class="block-checkbox">
            <ob-checkbox
              :label="'Множественное ли значение'"
              v-model="formData.has_multiple_value"
            />
          </div>
          <div class="block-checkbox">
            <ob-checkbox
              :label="'Оценка риска'"
              v-model="formData.need_risk_assessment"
            />
          </div>
          <div class="block-checkbox">
            <ob-checkbox
              :label="'Часть анкетных данных'"
              v-model="formData.is_questionnaire_data"
            />
          </div>
          <div class="block-checkbox">
            <ob-checkbox
              :label="'Требуется разработка'"
              v-model="formData.needDevelop"
              :disabled="true"
            />
          </div>
        </div>
      </div>

      <div v-show="activeTab == 'sources'">
        <div class="line-container">
          <div class="line-checkbox">
            <ob-checkbox
              :label="'Ручной ввод участником'"
              v-model="formData.handInputByParticipant"
            />
          </div>
          <div class="line-checkbox">
            <ob-checkbox
              :label="'Распознавание документов'"
              v-model="formData.documentScan"
            />
          </div>
          <div v-show="formData.documentScan" class="line-container">
            <ob-selector
              :items="listOf.documentsScanDocumentsList"
              :label="'Документы'"
              :placeholder="''"
              :isMultiselect="true"
              v-model="formData.documentsScanDocuments"
            />
          </div>
          <div v-show="formData.documentScan" class="line-container">
            <ob-selector
              :items="listOf.documentsScanServicesList"
              :label="'Сервисы'"
              :placeholder="''"
              :isMultiselect="true"
              v-model="formData.documentsScanServices"
              :displayExp="'uuid'"
            />
          </div>
          <div class="line-checkbox">
            <ob-checkbox
              :label="'Ручной ввод владельцем домена'"
              v-model="formData.handInputByOwner"
            />
          </div>
          <div v-show="formData.handInputByOwner">
            <ob-selector
              :items="documentsList"
              :label="'Документы'"
              :placeholder="''"
              :isMultiselect="true"
              v-model="formData.handInputDocuments"
            />
          </div>
        </div>
        <div class="line-container">
          <div class="line-checkbox">
            <ob-checkbox
              :label="'Внешние источники'"
              v-model="formData.foreignSources"
            />
          </div>
          <div v-show="formData.foreignSources">
            <ob-selector
              :items="foreignSourcesList"
              :label="'Сервисы'"
              :placeholder="''"
              :isMultiselect="true"
              v-model="formData.foreignSourceServices"
              :displayExp="'uuid'"
            />
          </div>
        </div>
        <div class="line-container">
          <div>
            <ob-switcher-checkbox
              :label="'Cовпадение значений обязательно'"
              v-model="formData.need_value_match"
            />
          </div>
        </div>
      </div>

    </ob-modal>
  </div>
</template>

<script>
import { uuid } from 'vue-uuid'
import data from '../../../resources/data.json'

import ObModal from 'common-components/src/obComponents/obModal'
import ObButton from 'common-components/src/obComponents/obButton'
import ObSelector from 'common-components/src/obComponents/obSelect'
import ObInput from 'common-components/src/obComponents/obInput'
import ObCheckbox from 'common-components/src/obComponents/obCheckbox'
import ObSwitcherCheckbox from 'common-components/src/obComponents/obSwitcherCheckbox'

const templateData = {
  title: { label: null },
  is_active: null,
  country_codes: [],
  requisite_group_uuid: null,
  datatype: null,
  class_code_uuid: null, // Эндпоинт фиксят
  resource_species_uuid: null,
  resource_type_uuid: null,
  need_for_registration: false,
  is_key_part: false,
  is_questionnaire_data: false,
  need_risk_assessment: false,
  needDevelop: false, // Всегда задизейблено, но через GET приходит
  has_multiple_value: false,
  need_manual_filling: false, // Участником или владельцем домена?
  need_verification: false, // Распознавание документов?
  text_min_len: null,
  text_max_len: null,
  text_available_symbols: null,
  text_mask: null,
  text_regexp: null, // datatype == boolean
  list_variant_uuids: null,
  list_dict_table_name: null,
  list_min_count: null,
  list_max_count: null,
  numeric_min: null,
  numeric_max: null,
  decimal_place_count: null,
  d_is_min_today: false,
  d_is_max_today: false,
  d_min: null,
  d_max: null,
  dt_is_min_now: false,
  dt_is_max_now: false,
  dt_min: null,
  dt_max: null,

  // Это вкладка источники данных
  handInputByParticipant: false,
  documentScan: false,
  documentsScanServices: [],
  documentsScanDocuments: [],
  handInputByOwner: false,
  handInputDocuments: [],
  foreignSources: false,
  foreignSourceServices: [],
  need_value_match: false
}

export default {
  components: {
    ObModal,
    ObSelector,
    ObInput,
    ObButton,
    ObCheckbox,
    ObSwitcherCheckbox
  },
  props: {

  },
  data () {
    return {
      activeTab: 'settings',
      listOf: {
        statuses: [],
        dataTypes: [],
        // ***BUG*** see open method
        documentsScanServicesList: [],
        documentsScanDocumentsList: []
        // ***BUG*** see open method
      },

      requisiteGroups:      data.requisite_groups,
      documentsList:        data.reg_docs,
      foreignSourcesList:   data.reg_docs,
      resourceClassList:    data.resourceClasses,
      resourceSpeciesList:  data.resourceSpecies,
      resourceTypesList:    data.resourceTypesList,
      countriesList:        data.countries,
      formData: {
        title: { label: null },
        is_active: null,
        country_codes: [],
        requisite_group_uuid: null,
        datatype: null,
        class_code_uuid: null, // Эндпоинт фиксят
        resource_species_uuid: null,
        resource_type_uuid: null,
        need_for_registration: false,
        is_key_part: false,
        is_questionnaire_data: false,
        need_risk_assessment: false,
        needDevelop: false, // Всегда задизейблено, но через GET приходит
        has_multiple_value: false,
        "need_manual_filling": false, // Участником или владельцем домена?
        "need_verification": false, // Распознавание документов?
        text_min_len: null,
        text_max_len: null,
        text_available_symbols: null,
        text_mask: null,
        text_regexp: null, // datatype == boolean
        list_variant_uuids: null,
        list_dict_table_name: null,
        list_min_count: null,
        list_max_count: null,
        numeric_min: null,
        numeric_max: null,
        decimal_place_count: null,
        d_is_min_today: false,
        d_is_max_today: false,
        d_min: null,
        d_max: null,
        dt_is_min_now: false,
        dt_is_max_now: false,
        dt_min: null,
        dt_max: null,

        // Это вкладка источники данных
        handInputByParticipant: false,
        documentScan: false,
        documentsScanServices: [],
        documentsScanDocuments: [],
        handInputByOwner: false,
        handInputDocuments: [],
        foreignSources: false,
        foreignSourceServices: [],
        need_value_match: false,
      }
    }
  },
  computed: {
    filteredResourceTypesList: ({ resourceTypesList, formData }) => resourceTypesList
      .filter(type => type.resource_species.uuid == formData.resource_species_uuid)
      .map(el => ({ uuid: el.uuid, name: el.resource_sub_type.name })),

    savePossible: ({ formData: { title, is_active, datatype, country_codes } }) =>
      title.label && (is_active !== null) && datatype && country_codes.length,
  },
  methods: {


    setTab(tabName) { this.activeTab = tabName },

    // отправка данных
    async onSave() {
      // const { title, is_active, datatype, need_for_registration, is_key_part,
      // is_questionnaire_data, need_risk_assessment, text_mask, ...others } = this.formData;

      // const data = { title, is_active, datatype, need_for_registration,
      //  is_key_part, is_questionnaire_data, need_risk_assessment, text_mask };

      // this.formData.country_codes.forEach( i => this.formData.title[i.code_short] = this.formData.title.label);
      this.formData.country_codes.forEach(code => {
        const country = this.countriesList.find(c => c.number_code == code);
        this.formData.title[country.short_symbol_code] = this.formData.title.label
      });

      this.formData.uuid = uuid.v4();
      console.log(this.formData);
      // await this.createField(this.formData);
      // this.$emit('create');
      this.close();
    },

    async open(data) {
      this.$refs['ob-modal'].open();

      if (uuid) {
        // this.formData = JSON.parse(JSON.stringify(templateData));
        // const data = await this.fetch(uuid);
        // console.log(data);
        // this.formData = data;
        this.formData.title.label = data;
      }

      // Статусы
      this.listOf.statuses = [
        { key: 1, value: true, title: 'Активно' },
        { key: 0, value: false, title: 'Выключено' },
      ];
      // Типы данных
      this.listOf.dataTypes = [
        { key: 1, title: "Число", value: 'NUMERIC' },
        { key: 2, title: "Строка", value: 'TEXT' },
        { key: 3, title: "Логический", value: 'BOOLEAN' },
        { key: 3, title: "Чеклист", value: 'CHECKLIST' },
        { key: 3, title: "Дата", value: 'DATE' },
        { key: 3, title: "Время", value: 'DATETIME' },
      ]
      // Группы реквизитов
      // Документы
      // Внешние источники
      // Классы
      // Виды
      // Типы

      // Страны

      // ***BUG*** selectbox mutates source array!!!
      this.listOf.documentsScanServicesList = JSON.parse(JSON.stringify(this.foreignSourcesList));
      // ***BUG***

      // ***BUG*** selectbox mutates source array!!!
      this.listOf.documentsScanDocumentsList = JSON.parse(JSON.stringify(this.documentsList));
      // ***BUG***
    },
    close() {
      this.setTab('settings');
      this.$refs['ob-modal'].close();
      this.formData = JSON.parse(JSON.stringify(templateData));
    }
  }
}
</script>

// <style lang="scss" scoped>

//   .line-container {
//     margin-bottom: 0 !important;
//   }
//   .switch-tabs {
//     button {
//       margin-right: 20px;
//     }
//   }

//   @import '../../static/css/popups.scss';

//   .switch-tabs {
//     margin-bottom: 40px;
//   }
//   .dx-checkbox {
//     width: 100%;
//   }
//   .block-name {
//     float: left;
//     width: 70%;
//     padding-right: 10px;
//   }
//   .block-status {
//     float: right;
//     width: 30%;
//     padding-left: 10px;
//   }
//   .block-left {
//     float: left;
//     width: 50%;
//     padding-right: 10px;
//   }
//   .block-right {
//     float: right;
//     width: 50%;
//     padding-left: 10px;
//   }
//   .list-block {
//     margin-right: -15px;
//     margin-left: -15px;
//   }
//   .block-checkbox {
//     display: inline-block;
//     vertical-align: top;
//     padding: 5px 15px;
//   }
//   .line-checkbox {
//     margin-bottom: 15px;
//   }
// </style>
